#include "stdafx.h"
#include "header.h"

int colorAlpha (BITMAP *bImage)
{
	// Since we'll be working with some non-32 bit images,
	// Allegro will mark everything as "translucent" when
	// they get loaded.  Normally this isn't a problem,
	// because we usually use the awesome power of Magic Pink.
	// However, if we want to use a hyrbrid of 32-bit and
	// non-32-bit images, we'll need to generate a valid
	// alpha channel for the image.  Everything that's not
	// magic pink will be turned into a "solid."

	int r;	// Red
	int g;	// Green
	int b;	// Blue

	for (int y = 0; y < bImage->h; y++)
	{
		for (int x = 0; x < bImage->w; x++)
		{
			int iColor = getpixel(bImage, x, y);
			r = getr(iColor);
			g = getg(iColor);
			b = getb(iColor);
			if(getpixel(bImage, x, y) != makecol(255, 0, 255))
				putpixel(bImage, x, y, makeacol(r, g, b, 255));
			else
				putpixel(bImage, x, y, makeacol(r, g, b, 0));
		}; //end for
	}; //end for

	return 0; //Success.
};


int colorReplace (BITMAP *bImage, const int iColor, const int iReplace)
{
	// Replaces all pixels of a given color in an Allegro
	// bitmap with another color.  Useful for "palette
	// swap" since the engine runs in 32 bits, not in
	// a 256 color palette.

	int iX;
	int iY;

	for(iY = 0; iY < bImage->h; iY++)
	{
		for(iX = 0; iX < bImage->w; iX++)
		{
			if(getpixel(bImage, iX, iY) == iColor)
				putpixel(bImage, iX, iY, iReplace);
		};
	};

	return 0;
};
