// -- header.h --
//
// A list of all the functions used by the program, collected into a header
// file for easy use.

#pragma once


// Global Defines

#define alignLEFT		0
#define alignCENTER		1
#define alignRIGHT		2

#define dDOWN			2
#define dLEFT			4
#define dRIGHT			6
#define dUP				8

#define maxHEIGHT		120
#define maxWIDTH		120


// Global Classes

#include "map_data.h"
#include "class_data.h"
#include "text_strings.h"
#include "txt_box.h"
#include "gui_integer_field.h"
#include "gui_windows.h"


// Global Functions

void butBlink(bool bSet);
int  butCheck(int iToCheck);
void butDisplay();
int  butKill(int iToKill);
int  butKillAll();
int  butNew(int iToSet, int iSetX, int iSetY, string tUp, string tDown, string tHover, int iOffset);
int  butReset(int iToSet);
void butUpdate();

int  classSetup();

int  colorAlpha (BITMAP *bImage);
int  colorReplace (BITMAP *bImage, const int iColor, const int iReplace);

void displayAll (void);

int  editMap (void);
int  editSelect (void);

BITMAP  *gfxLoad (string tFile, string tLocation);
int  gfxUnload (BITMAP *bImage);

int  guiKillAll (void);

bool keyCheck (int iKey);
int  keyReset (void);
int  keyUpdate (void);

int  htmManual (string tPage);

void mapProperties (void);

int  mouseGFX(string tFileName);

int  musPlay(int iTrack);
int  musStop();

int  parSettingsIni (void);
int  parStrings (CText &txtObj, string tFileName);

void screenDisplay (void);
void screenGet (BITMAP *mBitmap);

int  setupCore (void);

bool timeCheck (void);
void timeIncrease();
void timeSecondIncrease();
void timeStandby(int iToWait);
void timeWait();

void titleLanguageSelect (void);
int  titlePage (void);

int  txtCheckWordLength(int iFont, string tText);
int  txtCenter(int iFont, int iLocX, int iLocY, string tText, int iLength, int iToPrint);
void txtDisplay();
int  txtHeight (int iFontToUse, string tText, int iTextLength, int iNumberOfCharactersToPrint);
int  txtKill(int iToKill);
int  txtKillAll();
int  txtNew(int iToSet, int iLocX, int iLocY, string tText, int iFont, int iWidth, int iAlign, int iSpeed);
int  txtOut(int iFontToUse, int iTextLocationX, int iTextLocationY, string tText, int iTextLength, int iNumberOfCharactersToPrint);
int  txtReset (int iToSet, string tText);
int  txtSetBitmap (BITMAP *mToSetTo);
int  txtSetFont(int iFontNumberToSet, char cFontImageName[], int iFontWidthToSet, int iFontHeightToSet);
int  txtWidthOfChar (const int iFont, const int iChar);

int  usrLogin (void);



// Global Class Objects

extern CClass rank[250];
extern CIntFld intFld;
extern CMap map;
extern CText txt;
extern CText gTxt;
extern CText eTxt;
extern CTxtBox field;
extern CWindows win;



// Declare Global Variables and structures.

extern	BITMAP	*mBuffer;
extern	BITMAP	*mMouse;

extern	bool	sys_bClock;
extern	bool	sys_bDebugMode;
extern	bool	sys_bFPS;
extern	bool	sys_bUseVSync;
extern	bool	sys_bWindowedMode;
extern	string	sys_tLanguage;
extern	string	sys_tPath;

// Declare Global Constants

const	int		sys_iScreenHeight	= 480;
const	int		sys_iScreenWidth	= 640;

const   int     giUnitSourceX       = 32;
const   int     giUnitSourceY       = 32;
const   int     giUnitOffsetX       = 32;
const   int     giUnitOffsetY       = 48;
const   int     giUnitHeight        = 96;
const   int     giUnitWidth         = 96;
const	int		giTileX				= 32;
const	int		giTileY				= 32;
const	int		giTileHeight		= 48;
const	int		giTileWidth			= 32;
const	int		giTilesHigh			= 15;
const	int		giTilesWide			= 20;
const	int		giTerrainLayers		= 4;

const   string  sys_tBGPath         = "images/bg/";
const	string	sys_tButPath		= "images/buttons/";
const	string	sys_tHTML   		= "manual/";
const	string	sys_tMousePath		= "images/mouse/";
const	string	sys_tSysPath		= "system/";
const	string	sys_tTextPath		= "text/";
const	string	sys_tTilePath		= "images/tilesets/";
const	string	sys_tUnitPath		= "images/units/";
const	string	sys_tVersion		= "0.3.2";

