// -- MAP DATA CLASS --
// Working Version 0.1
// Based on Proposed Version 0.5
//
// This is the "universal map class" which is used to store whatever
// map is currently in memory.  Because of their size, only one map may
// be loaded and active at a time, which shouldn't be a problem because
// you only need one map at a time.
//
// IMPORTANT: If you add any variables to the data structure, make sure
// you add them to the Clear routines.



class CMap
{
public:
	
	// Header Data

	string tName;				// The name of the map.
	string tAuthor;				// Who made the made.
	string tDescription;		// A description of the map for multiplayer play or note-taking.
	int iMapVer;				// What version this map data was saved with.
	int iSizeX;					// How wide the map is.
	int iSizeY;					// How tall the map is.
	int iTileSet;				// Which tile set to use to display the map.

	// Terrain Data

	int iTerrain[4][maxWIDTH][maxHEIGHT];		// What terrain is in a given space at a given layer. 
	BITMAP *mTiles;								// A bitmap containing all the tiles.
    
    // Character and Unit Data
    
    int iGeneric[maxWIDTH][maxHEIGHT];             // What generic unit is in a given space.
	
	// Misc. Display Data
	
	bool bGrid;									// Whether or not to display the grid.

	// Public Functions and Routines

	int  Clear (void);					// Clears all map data.
	int  Display (int iX, int iY, int iOffsetX, int iOffsetY, bool bOjectsOn, int iWorkingLayer); // Displays the map to the buffer.
	int  Grid (int iX, int iY);			// Displays a grid on the screen.
	int  LoadTiles (string tFile);		// Loads a given tile set.
	int  ToggleGrid (void);				// Toggles the grid display.

private:

	// Private Functions and Routines

	int ClearHeader_ (void);
	int ClearTerrain_ (void);

	// Private Variables and Objects
};

