#include "stdafx.h"
#include "header.h"

// Title page and menu for SRPG Factory.  Not the title page or
// menu for individual projects.

class CTitlePage
{
public:
    int Page (void);
private:
    int PageKill_ (void);
    int PageSetup_ (void);
    BITMAP *mBG;
} title;

int CTitlePage::Page (void)
{
	// The main title page and menu loop.
    
    PageSetup_();
    
    while(!butCheck(0) && !keyCheck(KEY_ESC))
    {
        blit(mBG, mBuffer, 0, 0, 0, 0, mBG->w, mBG->h);
        displayAll();
        
        if(butCheck(4))
        {
            PageKill_();
            editSelect();
            PageSetup_();
        };

        if(butCheck(6))
        {
            PageKill_();
            htmManual("index");
            PageSetup_();
        };            
    };
    
    PageKill_();

	return 0;
};

int CTitlePage::PageKill_ (void)
{
    // Clears all the title screen's GUI objects and images.
    
    guiKillAll();
    destroy_bitmap(mBG);
    mBG = NULL;
  
    return 0; //success
};

int CTitlePage::PageSetup_ (void)
{
    // Sets up the Title Page for display.

    // Load the text.
    
    parStrings(txt, "title");

    // Set the background.
    
    mBG = gfxLoad("title_01", "bg");
    
    // Set Windows
    
    win.New(0, "window", 32, 432 - txtHeight(3, txt.Get("welcome"), 272, -1), 288, txtHeight(3, txt.Get("welcome"), 272, -1) + 16);
    
    // Set the buttons.
    
	butNew(1, 352, 232, "big_01", "", "", 0);
	txtNew(1, 480, 237, txt.Get("campaign"), 2, -1, alignCENTER, 0);
	butNew(2, 352, 264, "big_01", "", "", 0);
	txtNew(2, 480, 269, txt.Get("multi"), 2, -1, alignCENTER, 0);
	butNew(3, 352, 296, "big_01", "", "", 0);
	txtNew(3, 480, 301, txt.Get("tutorial"), 2, -1, alignCENTER, 0);
	butNew(4, 352, 328, "big_01", "", "", 0);
	txtNew(4, 480, 333, txt.Get("editor"), 2, -1, alignCENTER, 0);
	butNew(5, 352, 360, "big_01", "", "", 0);
	txtNew(5, 480, 365, txt.Get("options"), 2, -1, alignCENTER, 0);
	butNew(6, 352, 392, "big_01", "", "", 0);
	txtNew(6, 480, 397, txt.Get("help"), 2, -1, alignCENTER, 0);
	butNew(0, 352, 424, "big_01", "", "", 0);
	txtNew(0, 480, 429, txt.Get("quit"), 2, -1, alignCENTER, 0);
    
    // Set any additional text.
    
    txtNew(15, 40, 440 - txtHeight(3, txt.Get("welcome"), 272, -1), txt.Get("welcome"), 3, 272, alignLEFT, 0);
    txtNew(16, 32, 460, txt.Get("ver") + " " + sys_tVersion, 1, -1, alignLEFT, 0);
    
    return 0; // Success
};



int titlePage (void)
{
    // Calls the title page, which takes over for the
    // core loop.
    
    title.Page();
    
    return 0; // Success
};
