#include "stdafx.h"
#include "header.h"

class CUsrLogin
{
public:
    int Main (void);
private:
    void Done_ (void);
    void Loop_ (void);
    void Setup_ (void);
    BITMAP *mBG;
    string tNewLogin;
    string tNewName;
} login;

int CUsrLogin::Main (void)
{
    // The Main loop for the user login screen.
    
    // First, we need to find out how many user files are installed
    // on this setup, and who they are.
    
    // Second, we display the screen.
    
    Setup_();
    
    // Now we run the primary loop, waiting for user input.
    
    Loop_();
    
    // Finally, we log the user in, clear the screen and continue
    // on our way.
    
    Done_();
    
    return 0; // Success
};

void CUsrLogin::Done_ (void)
{
    // Clears everything that the login screen needed and
    // sets up any variables needed for the selected user.

    destroy_bitmap(mBG);
    guiKillAll();
};

void CUsrLogin::Loop_ (void)
{
    // The main loop that waits for user input.
    
    while(!butCheck(0)) //&& !keyCheck(KEY_ESC))
    {
        blit(mBG, mBuffer, 0, 0, 0, 0, mBG->w, mBG->h);
        displayAll();
    };
};

void CUsrLogin::Setup_ (void)
{
    // Sets up the display of the login screen
  
    parStrings(txt, "login");
    
    mBG = gfxLoad("generic_01", "bg");
    
    win.New(0, "window", 32, 272 - txtHeight(3, txt.Get("welcome"), 272, -1), 288, txtHeight(3, txt.Get("welcome"), 272, -1) + 16);
    win.New(1, "window", 32, 320, 288, 128);
    win.New(2, "window", 48, 304, 128, 16);
    
	butNew(0, 192, 408, "sml_01", "", "", 0);
	txtNew(0, 248, 413, txt.Get("create"), 2, -1, alignCENTER, 0);   
    
    // New User Window
    
    txtNew(2, 56, 312, txt.Get("new"), 2, -1, alignLEFT, 0);   
    txtNew(3, 48, 338, txt.Get("name"), 3, -1, alignLEFT, 0);   
    field.New(1, 2, &tNewLogin, 48, 352, 256, 16, 16);
    txtNew(4, 48, 372, txt.Get("login"), 3, -1, alignLEFT, 0);   
    field.New(2, 2, &tNewName, 48, 386, 256, 16, 16);
    
    // Welcome Text
    
    txtNew(1, 40, 280 - txtHeight(3, txt.Get("welcome"), 272, -1), txt.Get("welcome"), 3, 272, alignLEFT, 0);
};

int usrLogin (void)
{
    // Calls up the user login screen.
    
    login.Main();
    
    return 0; // Success
};
